"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const types_1 = tslib_1.__importDefault(require("../types"));
const babel_core_1 = tslib_1.__importDefault(require("./babel-core"));
const flow_1 = tslib_1.__importDefault(require("./flow"));
const shared_1 = require("../shared");
function default_1(fork) {
    const types = fork.use(types_1.default);
    const def = types.Type.def;
    fork.use(babel_core_1.default);
    fork.use(flow_1.default);
    // https://github.com/babel/babel/pull/10148
    def("V8IntrinsicIdentifier")
        .bases("Expression")
        .build("name")
        .field("name", String);
    // https://github.com/babel/babel/pull/13191
    // https://github.com/babel/website/pull/2541
    def("TopicReference")
        .bases("Expression")
        .build();
}
exports.default = default_1;
(0, shared_1.maybeSetModuleExports)(() => module);
//# sourceMappingURL=babel.js.map