"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const types_1 = tslib_1.__importDefault(require("./types"));
const path_visitor_1 = tslib_1.__importDefault(require("./path-visitor"));
const equiv_1 = tslib_1.__importDefault(require("./equiv"));
const path_1 = tslib_1.__importDefault(require("./path"));
const node_path_1 = tslib_1.__importDefault(require("./node-path"));
const shared_1 = require("./shared");
function default_1(plugins) {
    const fork = createFork();
    const types = fork.use(types_1.default);
    plugins.forEach(fork.use);
    types.finalize();
    const PathVisitor = fork.use(path_visitor_1.default);
    return {
        Type: types.Type,
        builtInTypes: types.builtInTypes,
        namedTypes: types.namedTypes,
        builders: types.builders,
        defineMethod: types.defineMethod,
        getFieldNames: types.getFieldNames,
        getFieldValue: types.getFieldValue,
        eachField: types.eachField,
        someField: types.someField,
        getSupertypeNames: types.getSupertypeNames,
        getBuilderName: types.getBuilderName,
        astNodesAreEquivalent: fork.use(equiv_1.default),
        finalize: types.finalize,
        Path: fork.use(path_1.default),
        NodePath: fork.use(node_path_1.default),
        PathVisitor,
        use: fork.use,
        visit: PathVisitor.visit,
    };
}
exports.default = default_1;
;
function createFork() {
    const used = [];
    const usedResult = [];
    function use(plugin) {
        var idx = used.indexOf(plugin);
        if (idx === -1) {
            idx = used.length;
            used.push(plugin);
            usedResult[idx] = plugin(fork);
        }
        return usedResult[idx];
    }
    var fork = { use };
    return fork;
}
(0, shared_1.maybeSetModuleExports)(() => module);
//# sourceMappingURL=fork.js.map